#include "main.h"

void fifoInit(struct fifo *fifo, int *buf, int size, struct task *task)
{
	fifo->size = size;
	fifo->buf = buf;
	fifo->free = size;
	fifo->wp = 0;
	fifo->rp = 0;
	fifo->task = task;
	return;
}

void fifoPut(struct fifo *fifo, int data)
{
	if (fifo->free == 0) {
		return;
	}
	fifo->buf[fifo->wp] = data;
	fifo->wp++;
	if (fifo->wp == fifo->size) {
		fifo->wp = 0;
	}
	fifo->free--;
	if (fifo->task != 0) {
		if (fifo->task->flag != 2) {
			taskRun(fifo->task, -1, 0);
		}
	}
	return;
}

int fifoGet(struct fifo *fifo)
{
	int data;
	if (fifo->free == fifo->size) {
		return -1;
	}
	data = fifo->buf[fifo->rp];
	fifo->rp++;
	if (fifo->rp == fifo->size) {
		fifo->rp = 0;
	}
	fifo->free++;
	return data;
}

int fifoStat(struct fifo *fifo)
{
	return fifo->size - fifo->free;
}
